; ############################################################

    .486                      ; create 32 bit code
    .model flat, stdcall      ; 32 bit memory model
    option casemap :none      ; case sensitive

    include Marker.inc        ; local includes for this file

    CADD MACRO quoted_text
      LOCAL vname,lbl
        jmp lbl
          vname db quoted_text,0
        lbl:
      EXITM <ADDR vname>
    ENDM

.code

; ############################################################

start:

      call Main
      invoke ExitProcess,eax

; ############################################################

Main proc

    LOCAL hWnd     :DWORD
    LOCAL hCursor  :DWORD
    LOCAL hIcon    :DWORD
    LOCAL msg      :MSG
    LOCAL wc       :WNDCLASSEX

    invoke LoadCursor,NULL,IDC_ARROW
    mov hCursor, eax

    invoke LoadIcon,NULL,IDI_ASTERISK
    mov hIcon, eax

    szText szClassName,"smallwin_Class"
    szText szDisplayName,"Drawing Markers"

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_VREDRAW or \
                           CS_HREDRAW
    mov wc.lpfnWndProc,    offset WndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    mov wc.hInstance,      400000h
    mov wc.hbrBackground,  COLOR_BTNFACE+1
    mov wc.lpszMenuName,   NULL
    mov wc.lpszClassName,  offset szClassName
    m2m wc.hIcon,          hIcon
    m2m wc.hCursor,        hCursor
    m2m wc.hIconSm,        hIcon

    invoke RegisterClassEx, ADDR wc

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          150,150,500,300,
                          NULL,NULL,
                          400000h,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayWindow hWnd,SW_SHOWNORMAL

  StartLoop:
    invoke DispatchMessage,  ADDR msg
    invoke GetMessage,ADDR msg,NULL,0,0
    cmp eax, 0
    jne StartLoop

    mov eax, msg.wParam
    ret

Main endp

; ############################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    LOCAL hDC :DWORD
    LOCAL hrgn:DWORD
    LOCAL Ps  :PAINTSTRUCT
    LOCAL Rct :RECT

    .if uMsg == WM_LBUTTONDOWN
	invoke GetClientRect,hWin, ADDR Rct
	invoke CreateRectRgn,Rct.left, Rct.top, 
                      	     Rct.right, Rct.bottom
	mov hrgn,eax
	mov eax,index
	MOVEPOINTS ptMouseDown[eax]
	invoke PtInRegion,hrgn,ptMouseDown[eax].x,
			       ptMouseDown[eax].y
      .if eax
	mov eax,index
	invoke Marker,ptMouseDown[eax].x,
		      ptMouseDown[eax].y,
		      hWin
	add index,8
      .endif

	return 0

    .elseif uMsg == WM_SIZE
	mov ecx,index
mark:	jcxz done
	sub ecx,8
	push ecx
	invoke Marker,ptMouseDown[ecx].x,
		      ptMouseDown[ecx].y,
		      hWin
	pop ecx
	jmp mark

done:	return 0

    .elseif uMsg == WM_DESTROY
      invoke PostQuitMessage,NULL
      return 0

    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; ############################################################

Marker proc x    :DWORD,
            y    :DWORD,
            hwnd :DWORD

	LOCAL hdc : DWORD

	invoke GetDC,hwnd
	mov hdc,eax

	mov eax,x
	sub eax, 10
	invoke MoveToEx,hdc,eax,y,NULL
	mov eax,x
	add eax, 10
	invoke LineTo,hdc,eax,y
	mov eax,y
	sub eax, 10
	invoke MoveToEx,hdc,x,eax,NULL
	mov eax,y
	add eax, 10
	invoke LineTo,hdc,x,eax

	invoke ReleaseDC,hwnd,hdc

	return 0

Marker endp

; ############################################################

end start
